
!UiTreeViewport methodsFor: 'add/remove' stamp: 'mt 10/10/2010 11:35:20.713'!
addMorph: aMorph atIndex: aModelIndex

	| col row indent |	
	aMorph setProperty: #modelIndex toValue: aModelIndex.
	aMorph setProperty: #isExpanded toValue: false.
	aMorph setProperty: #hasChildren toValue: aModelIndex hasChildren.
	
	row := self addRowFor: aModelIndex.
	row items add: aMorph.
	
	col := self columnFor: aModelIndex.
	col items add: aMorph beforeIndex: (rows indexOf: row).
	
	self addMorphBack: aMorph.
	
	"Correct indent."
	indent := 0.
	(aModelIndex column = 1) ifTrue: [
		(col itemBefore: aMorph)
			ifNil: [indent := self indent] "root"
			ifNotNil: [:item |
				"The item before is my parent. Add additional indentation."
				(item valueOfProperty: #modelIndex) = aModelIndex parent
					ifTrue: [indent := (item valueOfProperty: #indent) + self indent].
				"The item before is my sibling. Use its indentation."
				(item valueOfProperty: #modelIndex) parent = aModelIndex parent
					ifTrue: [indent := item valueOfProperty: #indent]]].
	aMorph setProperty: #indent toValue: indent.! !

!UiTreeViewport methodsFor: 'drawing' stamp: 'mt 10/10/2010 11:14:04.16'!
drawOn: aCanvas
	
	self
		drawSelectionOn: aCanvas;
		drawTreeStructureOn: aCanvas.
	super drawOn: aCanvas.! !

!UiTreeViewport methodsFor: 'drawing' stamp: 'mt 10/10/2010 11:56:07.146'!
drawTreeStructureOn: aCanvas
	
	| first last |
	columns first width < aCanvas clipRect left
		ifTrue: [^ self].
	
	first := self cellIndexFromPoint: (self bounds pointNearestTo: aCanvas clipRect topLeft).
	last := self cellIndexFromPoint: (self bounds pointNearestTo: aCanvas clipRect bottomLeft).

	first isNil | last isNil ifTrue: [^ self].

	first y to: last y do: [:rowIndex |
		| item cellBounds form |
		cellBounds := self cellBoundsFor: 1@rowIndex.
		item := (rows at: rowIndex) items first.
		form := UiSilkIcons bulletArrowDownIcon.
		form := (item valueOfProperty: #hasChildren)
			ifFalse: [nil]
			ifTrue: [(item valueOfProperty: #isExpanded)
				ifFalse: [form rotateBy: #left centerAt: 8@8]
				ifTrue: [form]].

		form ifNotNil: [
			aCanvas
				translucentImage: form
				at: (cellBounds left + ((item valueOfProperty: #indent) - self indent))
					@ (cellBounds top + (cellBounds height - form height // 2))]].! !

!UiTreeViewport methodsFor: 'accessing' stamp: 'mt 10/10/2010 11:56:19.035'!
indent

	^ indent ifNil: [indent := 12]! !

!UiSimpleModelIndex methodsFor: 'testing - hierarchy' stamp: 'mt 10/10/2010 11:35:51.993'!
hasChildren

	^ model hasChildrenFor: self! !
